 const flashBlks
cls ." Pause tape to prep "
cr dup flashBlks . ." blocks."
: inline 
  create -1 allot 
  dup 256 < if c, else , then 
  $80 latest lfa>ffa c! 
; immediate 
$B5 inline SerFlWr
11 kern inline VDskFind
15 kern inline +tape>
16 kern inline -tape
17 kern inline tape>
3 const kExtFlash
19 kern const packet
64 const packetLen
13 const .goodPackets
15 const .loadMap
8 const blkPages
vram 306 + const flBuff

flashBlks arr physBlks

create dskBuff 512 allot
blk* @ var oldBlk*
dskBuff blk* !

: flashLoadPrep  ( blk# pkts --)
  dskBuff 512 -1 fill 	( empty block; blk# pkts)
  0 do  ( blk# /pkts/)
    vram over i + dup >blk ( write the block; blk# vram blk#+i /blk#+i/)
    VDskFind i physBlks ! ( blk#; blk# /blk#+i vram/ /phys blkMap[i]/)
  loop
;

: mapBit
  dup 3 >> packet + .loadMap + swap 7 and 1 swap <<
;

: mapClr
  mapBit neg 1- over ic@ and swap ic!
;

: flWr
  flBuff swap over 256 cmove SerFlWr
;

: tapeBlk> ( blkIndex --)
  0 blkPages 0 do ( blkIndex goodFrames )
    >r dup tape> ( got packet, written into iRam; blkIndex buff|0 : goodFrames)
    ?dup if
      dskBuff i packetLen * + packetLen cmove  ( Copy packet to ext ram.)
      dup mapClr r> 1+ >r  ( clear map bit and inc goodFrames)
    then
    r>
  loop
  blkPages = if  ( blkIndex /blkPages goodFrames/)
    dup mapBit over ic@ or swap ic!
    physBlks @ dskBuff 2dup flWr ( blkIndex physBlks[blkIx] buff /physArray[blk#] blk*/ )
    swap 1+ swap 256 + flWr ( blkIndex /physBlks[blkIx+1] buff+256/ )
    8 +
  else
    mapClr
  then
;

: load"  ( div , name --)
  cls
  ." Hit key & start audio."
  key drop
  +tape>
  ic@ kExtFlash = if
	0 flashBlks 0 do
      i tapeBlk>
	loop
  else 0
  then
  [ find flashBlks ] literal
  dup @ current ! dp !
  -tape  ( /pkts/ )
;

flashBlks flashLoadPrep
packet 7 + ic@ load"
