cls ." Compiling..."

: dconst
  create -1 allot
  71 c, d,
; immediate

3.1415927 dconst pi

: sphere ( r )
	2dup 2dup f* f*
	1.3333333 f* pi f*
; ( r^3*4/3*pi )

: lozEqDt ( dt x y z )
 [ -8.0 3.0 f/ ] dliteral
 2over f* 2swap d>r ( dxy[-bz]:z)
 d>r 2over 2over f* ( dxy[xy]:[-bz]z)
 dr> f+ dr> 2swap d>r ( dxyz:Z)
 fneg 28.0 f+ d>r ( dxy:[r-z]Z)
 2over dr> f* 2over f- ( dxy[[x*[r-z]]-y]:Z)
 d>r f- -10.0 f* ( d[-s[x-y]]:YZ)
 2over f* 2swap ( [dX]d:YZ)
 dr> 2over f* 2swap ( d x' y' d:Z)
 dr> f*
; ( Dt x' y' z' )

: lozSum ( dxXYyZz)
  f+ d>r f+ d>r f+ ( dx':y'z')
  dr> dr>
;

2048 bytes history
0 var his

: mplot ( xy)
  2dup 1 pen plot
  his @ >r
  r history ( xyh^:h)
  dup c@ over 1+ c@
  2 pen plot ( xyh^)
  swap over 1+ c! c!
  r> 2+ 2047 and his !
;

: .loz ( Dt x0 y0 z0 --)
    0 history 2048 0 fill
	1 vmode cls
	begin
		2over 2.2 f* ( dxyz[y*2.2])
		fint drop 80 + >r ( dxyz:py)
		2dup 2.5 f* ( dxyz[z*2.5]:py)
		fint drop 5 + r> ( dxyz/[pz][py]/plot )
		( cr swap . swap . sp i@ . )
		mplot
		d>r d>r 2over ( dxd:yz)
		2over dr> dr>  ( dxdxyz)
		2over 2over d>r d>r ( dxdxyz:yz)
		lozEqDt ( dxXYZ:yz)
		dr> 2swap dr> ( dxXYyZz)
		lozSum ( dx'y'z)
	inkey 32 = until
	2drop 2drop 2drop 2drop
	0 vmode
;

: bigFib
	1.0 1.0
	begin
		2dup f.
		2swap 2over f+
	2dup 3.0e38 f< 0= until
	2drop 2drop
;

: fpDemo
  pi f. ( 3.141592e+00 )
  key drop cr

  6371.0 sphere f. ( 1.083206e+12 Km3)
  key drop cr

  0.01 1.0 0.0 0.0 .loz

  bigFib
;

." Type fpDemo <exe> to run "
